**This is a _Chrome extension_ and _Firefox addon_ that adds notes to Gmail conversations. One note per conversation.**

- 100% free and open source! 

- Notes marked on one computer could be retrieved from another computer.

- All notes are stored in your own Google Drive account, no 3rd party server is used.
 
- All communications and authentications are directly between your browser and Google Drive.

- The extension could only access those Google Drive files that are created by the it. 

- An offline Google Drive token would be collected to avoid logging in every time the Gmail is opened. But you could disconnect (revoke the token) any time.

- No tracking code is added.

- See the extension website for the source code repository.

- Integrate with [Simple Mobile CRM](https://mobilecrm.io) (require extra sign in)

**Dependencies (included in source code)**

- [jQuery](https://jquery.com/)

- [jQuery Popup Overlay](https://github.com/vast-engineering/jquery-popup-overlay)

- [jQuery Simple Color](https://github.com/recurser/jquery-simple-color)

- [Featherlight](https://noelboss.github.io/featherlight/)

- [js-lru](https://github.com/rsms/js-lru)

- [TinyMCE](https://www.tiny.cloud/)

- [Bulma CSS](https://bulma.io/)

- [ikooni icons](https://www.iconfinder.com/iconsets/ikooni-outline-free-basic)

**Chrome Store Download**

- <https://chrome.google.com/webstore/detail/simple-gmail-notes/jfjkcbkgjohminidbpendlodpfacgmlm>

**Firefox Addon Download**

- <https://addons.mozilla.org/en-US/firefox/addon/simple-gmail-notes/>


**More Technical Details**
 - <http://blog.walty8.com/simple-gmail-notes-chrome-extension/>

**About Source Code Update**

- To see the latest source code in production, one is always encouraged to use source code viewer like [Chrome extension source viewer](https://chrome.google.com/webstore/detail/chrome-extension-source-v/jifpbeccnghkjeaalbbjmodiffmgedin?hl=en), and directly inspect the source code from Chrome store. The source code is never obfuscated.

